#include <stdio.h>
#include <stdlib.h>
#include <math.h>

main(int argc, char *argv[]) {
    float gamma;
    int i, value, black;

    if (argc!=3 || sscanf(argv[1], "%f", &gamma)!=1 || sscanf(argv[2], "%d", &black)!=1) {
        printf("usage: mkucr gamma black\n");
        exit(-1);
    }

    printf("; Undercolour removal file\n;\n;\n");
    for (i=0; i<256; i++)
        printf("%3d %3d\n", (i*black+50)/100, (i*black+50)/100);
    printf(";\n;HSI CMY matrix\n;\n");
    printf(";256   0   0\n");
    printf(";  0 256   0\n");
    printf(";-16   0 256\n;\n");
    printf("HSI CMYK density map\n;\n");
    for (i=0; i<256; i++) {
        value=(int) (255.0*pow((double) i / 255.0, gamma)+0.5);
        printf("%3d %3d %3d %3d\n", value, value, value, value);
    }
    return 0;
}
