#include <stdio.h>
#include <stdlib.h>

#define LOC_WIDTH   0xD876E
#define LOC_HEIGHT  0xD878A

int main(int nArgs, char * pszArgs[])
{
    FILE * pFile;
    unsigned long fLen;
    unsigned long width;
    unsigned long height;

    printf("ResReaper for THUG2, v0.1 by reaper\n");
    printf("ONLY WORKS ON RELOADED EXES!\n\n");

    if(nArgs > 1)
    {
        pFile = fopen(pszArgs[1], "r+b");
        fseek(pFile, 0, SEEK_END);
        fLen = ftell(pFile);

        if(fLen > LOC_HEIGHT)
        {
            fseek(pFile, LOC_WIDTH, SEEK_SET);
            fread(&width, 4, 1, pFile);
            fseek(pFile, LOC_HEIGHT, SEEK_SET);
            fread(&height, 4, 1, pFile);

            printf("Your current 800x600 resolution is: %dx%d (WxH)\n", width, height);

            printf("Enter your new desired width: ");
            scanf("%u", &width);

            printf("Enter your new desired height: ");
            scanf("%u", &height);

            fseek(pFile, LOC_HEIGHT, SEEK_SET);
            fwrite(&height, 4, 1, pFile);
            fseek(pFile, LOC_WIDTH, SEEK_SET);
            fwrite(&width, 4, 1, pFile);

            printf("The file was patched successfully!\n");
        }
        else
        {
            printf("This does not seem to be a Reloaded exe.. aborting\n");
        }

        fclose(pFile);
    }

    system("PAUSE");
    return 0;
}
